import sys
import os
forge = sys.modules["forge"]

def setup(module):
	srcList = [	"oiio.pmh",
				"ImageOIIO",
				"oiioDL" ]

	dll = module.DLL( "fexOiioDL", srcList )

	deplibs = forge.basiclibs + [
				"fePluginLib" ]

	incPath = os.path.join(forge.oiio_dist,'include')
	libPath = os.path.join(forge.oiio_dist,'lib')

	module.includemap = { 'oiio' : incPath }

	dll.linkmap = { "gfxlibs": forge.gfxlibs }

	if forge.fe_os == "FE_LINUX":
		dll.linkmap['oiio'] = "-Xlinker -rpath='" + libPath + "'"
		dll.linkmap["oiio"] += " -L" + libPath + " -lOpenImageIO"
	elif forge.fe_os == "FE_WIN32" or forge.fe_os == "FE_WIN64":
		dll.linkmap["oiio"] = ""	# TODO

	forge.deps( ["fexOiioDLLib"], deplibs )

	forge.tests += [
		("inspect.exe",	"fexOiioDL",						None,	None) ]

	if 'viewer' in forge.module_list and os.path.exists('ext/viewer'):
		forge.tests += [
			("xImage.exe",	"fexOiioDL ../media/image/FreeElectron64.tif 10",
																None,	None),
			("xImage.exe",	"fexOiioDL 10",						None,	None),
			("xRay.exe",	"fexOiioDL 30",						None,	None) ]
	else:
		sys.stdout.write("-viewer ")

#	module.Module('test')

def auto(module):
	if forge.oiio_dist == '':
		return 'unset'

	test_file = """
#include <OpenImageIO/imagebuf.h>

int main(void)
{
	return(0);
}
    \n"""

	incPath = os.path.join(forge.oiio_dist,'include')
	libPath = os.path.join(forge.oiio_dist,'lib')

	forge.includemap['oiio'] = incPath
#	forge.linkmap['oiio'] = '-L' + libPath + ' -lOpenImageIO'

	result = forge.cctest(test_file)

	forge.includemap['oiio'] = ''
	forge.linkmap['oiio'] = ''

	return result
