import os
import sys
forge = sys.modules["forge"]

def setup(module):
	srcList = [	"oplab.pmh",
				"BindEditOp",
				"CurvaceousOp",
				"FusionOp",
				"GridWrapOp",
				"NexusOp",
				"RecordOp",
				"XRayOp",
				"oplabDL" ]

	dll = module.DLL( "fexOpLabDL", srcList )

	deplibs = forge.corelibs+ [
				"fexMathLib",
				"fexOperateDLLib",
				"fexSurfaceDLLib",
				"fexWindowLib"	]

	forge.deps( ["fexOpLabDLLib"], deplibs )

	forge.tests += [
		("inspect.exe",	"fexOpLabDL",					None,	None) ]

	if 'graphviz' in forge.module_list and os.path.exists('ext/graphviz') and os.path.exists('/usr/include/graphviz/gvc.h'):
		module.cppmap = {}
		module.cppmap['meta'] = ' -DFE_USE_GRAPHVIZ'
	else:
		sys.stdout.write("-graphviz ")
