/*	Copyright (C) 2003-2013 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __surface_SurfaceAccessibleCatalog_h__
#define __surface_SurfaceAccessibleCatalog_h__

namespace fe
{

/**************************************************************************//**
    @brief Catalog Surface Binding

	@ingroup surface
*//***************************************************************************/
class FE_DL_EXPORT SurfaceAccessibleCatalog:
	public SurfaceAccessibleBase
{
	public:
								SurfaceAccessibleCatalog(void)				{}
virtual							~SurfaceAccessibleCatalog(void)				{}

								//* as SurfaceAccessibleI
virtual	void					bind(Instance a_instance)
								{	setCatalog(
											a_instance.cast< sp<Catalog> >()); }
virtual	BWORD					isBound(void)
								{	return catalog().isValid(); }

const	std::vector<SurfaceAccessibleI::Spec>&
								attributeSpecs(SurfaceAccessibleI::Element
										a_element) const;

virtual sp<SurfaceAccessorI>	accessor(SurfaceAccessibleI::Element a_element,
										String a_name,
										SurfaceAccessibleI::Creation a_create);
virtual sp<SurfaceAccessorI>	accessor(SurfaceAccessibleI::Element a_element,
										SurfaceAccessibleI::Attribute
										a_attribute,
										SurfaceAccessibleI::Creation a_create);

virtual	BWORD					discard(SurfaceAccessibleI::Element a_element,
										String a_name);

								//* Catalog specific
		sp<Catalog>				catalog(void);
		void					setCatalog(sp<Catalog> a_spCatalog)
								{	m_spCatalog=a_spCatalog; }
		void					setKey(String a_key)
								{	m_key=a_key; }

	protected:
virtual	void					reset(void);

	private:
		sp<SurfaceAccessorI>	accessor(void);

		sp<Catalog>				m_spCatalog;
		String					m_key;
};

} // namespace

#endif /* __surface_SurfaceAccessibleCatalog_h__ */
